import discord
import random
import aiohttp
import asyncio

from os import getenv
from dotenv import load_dotenv
from discord import app_commands
from discord import Embed
#from discord.app_commands import Choice
from discord.ext import commands

from classes.my_cog import MyCog


class Fact(MyCog):
    def __init__(self, bot):
        super().__init__(bot)
        self.bot = bot

    @app_commands.command(name="fact")
    async def fact(self, interaction: discord.Interaction, private: bool=False):
        """
        Vous reprendriez bien un petit shot de culture G ?

        :param interaction: discord interaction
        :param private: Garder ce petit bijou pour soi
        """

        headers = {
            'Authorization': f'Bearer {getenv("WIKIMEDIA_ACCESS_TOKEN")}',
            'User-Agent': 'Staticky (https://mp2i-vms.fr)'
        }

        try:
            async with aiohttp.ClientSession() as session:
                response = await session.get("https://fr.wikipedia.org/api/rest_v1/page/random/summary", headers=headers)
                data = await response.json()

                embed = Embed(
                        title=data.get("title", "Titre inconnu"),
                        url=data.get("content_urls").get("desktop").get("page"),
                        description=data.get('extract')
                )

                embed.set_thumbnail(url=data.get('thumbnail').get('source'))

                await interaction.response.send_message("", embed=embed, ephemeral=private)
        except Exception as e:
            await interaction.response.send_message(f"Le message n'a pas pu être envoyé...\n`Erreur : {e}`",
                                                    ephemeral=True)


async def setup(bot):
    await bot.add_cog(Fact(bot))
